Index: trunk/src/lib/graphics/importer/md3/md3_data.cc
===================================================================
--- trunk/src/lib/graphics/importer/md3/md3_data.cc	(revision 8490)
+++ trunk/src/lib/graphics/importer/md3/md3_data.cc	(revision 8490)
@@ -0,0 +1,401 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
+
+#include "md3_data.h"
+
+#include "md3_bone_frame.h"
+#include "md3_tag.h"
+#include "md3_mesh.h"
+
+#include "material.h"
+
+#include "debug.h"
+
+namespace md3
+{
+
+/********************************************************************************
+ *   MD3Data                                                                    *
+ ********************************************************************************/
+
+/**
+  \brief simple constructor
+*/
+MD3Data::MD3Data(const std::string& modelFileName, const std::string& skinFileName, float scale)
+{
+
+
+
+  this->loadModel(modelFileName);
+//   this->loadSkin(skinFileName);
+}
+
+
+/**
+  \brief simple destructor
+
+  this will clean out all the necessary data for a specific md2model
+*/
+MD3Data::~MD3Data()
+{
+  delete this->header;
+}
+
+
+
+/**
+  \brief this will load the whole model data (vertices, opengl command list, ...)
+* @param fileName: the name of the model file
+  \return true if success
+*/
+bool MD3Data::loadModel(const std::string& fileName)
+{
+  FILE *pFile;                            //file stream
+//  char* buffer;                           //buffer for frame data
+  int fileOffset = 0;                     // file data offset
+
+
+
+  //! @todo this chek should include deleting a loaded model (eventually)
+  if (fileName.empty())
+    return false;
+
+  PRINTF(0)("opening file: %s\n", fileName.c_str());
+  pFile = fopen(fileName.c_str(), "rb");
+  if( unlikely(!pFile))
+    {
+      PRINTF(1)("Couldn't open the MD3 File for loading. Exiting.\n");
+      return false;
+    }
+  fileOffset += this->readHeader(pFile, fileOffset);
+  /* check for the header version: make sure its a md2 file :) */
+  if( unlikely(this->header->version != MD3_VERSION) && unlikely(this->header->ident != MD3_IDENT))
+    {
+      PRINTF(1)("Couldn't load file %s: invalid file format: stop loading\n", fileName.c_str());
+      return false;
+    }
+
+
+    // check if the filesize is correct
+    if( this->header->fileSize > this->header->tagStart &&
+        this->header->fileSize >= this->header->meshStart)
+    {
+      bool bBoneFrames, bTags, bMeshes;
+      bBoneFrames = ( this->header->boneFrameNum == 0);
+      bTags = ( this->header->tagNum == 0);
+      bMeshes = ( this->header->meshNum == 0);
+
+      // read different parts of the model in correct order
+      while( !(bBoneFrames && bTags && bMeshes))
+      {
+        printf("while, fileOffset = %i\n", fileOffset);
+        if( fileOffset == this->header->boneFrameStart && !bBoneFrames)
+        {
+          fileOffset += this->readBoneFrames(pFile, fileOffset);
+          bBoneFrames = true;
+        }
+        else if( fileOffset == this->header->tagStart && !bTags)
+        {
+          fileOffset += this->readTags(pFile, fileOffset);
+          bTags = true;
+        }
+        else if( fileOffset == this->header->meshStart && !bMeshes)
+        {
+          fileOffset += this->readMeshes(pFile, fileOffset);
+          bMeshes = true;
+        }
+      }
+
+    }
+
+  fclose(pFile);
+
+  return true;
+}
+
+
+/**
+  \brief loads the skin/material stuff
+* @param fileName: name of the skin file
+  \return true if success
+*/
+bool MD3Data::loadSkin(const std::string& fileName)
+{
+//   if( fileName.empty())
+//     {
+//       this->skinFileName = "";
+//       return false;
+//     }
+//
+//   this->skinFileName = fileName;
+//
+//   this->material.setName("md2ModelMaterial");
+//   this->material.setDiffuseMap(fileName);
+//   this->material.setIllum(3);
+//   this->material.setAmbient(1.0, 1.0, 1.0);
+
+  return true;
+}
+
+
+/**
+ * read heaader
+ */
+int MD3Data::readHeader(FILE* pFile, int fileOffset)
+{
+  PRINTF(0)("Reading Header\n");
+
+  this->header = new MD3Header;
+  fread(this->header, 1, sizeof(MD3Header), pFile);
+
+    //header debug:
+  PRINTF(0)("MD3 Header debug section======================================\n");
+  printf("ident: %i\n", this->header->ident);
+  printf("version: %i\n", this->header->version);
+  printf("filename: %s\n", this->header->filename);
+  printf("boneFrameNum: %i\n", this->header->boneFrameNum);
+  printf("tag number: %i\n", this->header->tagNum);
+  printf("mesh number: %i\n", this->header->meshNum);
+  printf("max tex num: %i\n", this->header->maxTexNum);
+  printf("bone frame start: %i\n", this->header->boneFrameStart);
+  printf("tag start: %i\n", this->header->tagStart);
+  printf("mesh start: %i\n", this->header->meshStart);
+  printf("fileSize: %i\n", this->header->fileSize);
+
+  return sizeof(MD3Header);
+}
+
+
+/**
+ * read bone frames
+ */
+int MD3Data::readBoneFrames(FILE* pFile, int fileOffset)
+{
+  PRINTF(0)("Reading Bone Frames\n");
+
+  this->boneFrames = new MD3BoneFrame*[this->header->boneFrameNum];
+
+  for( int i = 0; i < this->header->boneFrameNum; i++)
+  {
+    this->boneFrames[i] = new MD3BoneFrame(i);
+
+    MD3BoneFrameData* md = new MD3BoneFrameData;
+    fread(md, 1, sizeof(MD3BoneFrameData), pFile);
+    this->boneFrames[i]->data = md;
+  }
+
+  return this->header->boneFrameNum * sizeof(MD3BoneFrameData);
+}
+
+
+/**
+ * read the tags
+ */
+int MD3Data::readTags(FILE* pFile, int fileOffset)
+{
+  PRINTF(0)("Reading Tags\n");
+
+  for( int i = 0; i < this->header->boneFrameNum; i++)
+  {
+    this->boneFrames[i]->tags = new MD3Tag*[this->header->tagNum];
+
+    for( int j = 0; j < this->header->tagNum; j++)
+    {
+      this->boneFrames[i]->tags[j] = new MD3Tag();
+      MD3TagData* md = new MD3TagData;
+      fread(md, 1, sizeof(MD3TagData), pFile);
+      this->boneFrames[i]->tags[j]->data = md;
+    }
+  }
+
+  return this->header->boneFrameNum * this->header->tagNum * sizeof(MD3TagData);
+}
+
+
+/**
+ * read meshes
+ */
+int MD3Data::readMeshes(FILE* pFile, int fileOffset)
+{
+  PRINTF(0)("Reading Mesh Data\n");
+
+  fileOffset = 0;
+
+  this->meshes = new MD3Mesh*[this->header->meshNum];
+
+  for( int i = 0; i < this->header->meshNum; i++)
+  {
+    this->meshes[i] = new MD3Mesh();
+
+    int localFileOffset = 0;
+    bool   bTriangles, bTexVecs, bVertices, bTextures;            //!< the parts that have been read so far
+
+    //start reading mesh data
+    MD3MeshHeader* md = new MD3MeshHeader;
+    fread(md, 1, sizeof(MD3MeshHeader), pFile);
+    this->meshes[i]->header = md;
+    localFileOffset += sizeof(MD3MeshHeader);
+
+    PRINTF(0)("MD3 Mesh Header debug section\n");
+    printf("ident: %i\n", md->id);
+    printf("filename: %s\n", md->name);
+    printf("meshFrameNum: %i\n", md->meshFrameNum);
+    printf("textureNum: %i\n", md->textureNum);
+    printf("vertexNum: %i \n", md->vertexNum);
+    printf("triangleNum: %i\n", md->triangleNum);
+    printf("triangleStart: %i\n", md->triangleStart);
+    printf("textureStart: %i\n", md->textureStart);
+    printf("texVecStart: %i\n", md->texVecStart);
+    printf("vertexStart: %i\n", md->vertexStart);
+    printf("fileSize: %i\n", md->meshSize);
+
+    if( unlikely(this->meshes[i]->header->id != MD3_IDENT))
+    {
+      PRINTF(1)("Wrong MD3 mesh file tag, file %s could be corrupt\n", this->filename.c_str());
+      return false;
+    }
+
+    // check which parts to be loaded
+    bTriangles = ( this->meshes[i]->header->triangleNum == 0);
+    bTexVecs = ( this->meshes[i]->header->vertexNum == 0);
+    bVertices = ( this->meshes[i]->header->meshFrameNum == 0);
+    bTextures = ( this->meshes[i]->header->textureNum == 0);
+
+    // now read the data block whise
+    while( !(bTriangles && bTexVecs && bVertices && bTextures))
+    {
+      PRINTF(0)("while2: localOffset = %i\n", localFileOffset);
+      if( localFileOffset == this->meshes[i]->header->triangleStart  && !bTriangles)
+      {
+        localFileOffset += this->readMeshTriangles(pFile, localFileOffset, i);
+        bTriangles = true;
+      }
+      else if( localFileOffset == this->meshes[i]->header->textureStart && !bTextures)
+      {
+        localFileOffset += this->readMeshTextures(pFile, localFileOffset, i);
+        bTextures = true;
+      }
+      else if( localFileOffset == this->meshes[i]->header->texVecStart && !bTexVecs)
+      {
+        localFileOffset += this->readMeshTexVecs(pFile, localFileOffset, i);
+        bTexVecs = true;
+      }
+      else if( localFileOffset == this->meshes[i]->header->vertexStart && !bVertices)
+      {
+        localFileOffset += this->readMeshVertices(pFile, localFileOffset, i);
+        bVertices = true;
+      }
+    }
+    fileOffset += localFileOffset;
+    PRINTF(0)("finished reading mesh %i, got %i of %i byes\n", i, localFileOffset, md->meshSize);
+  }
+  return fileOffset;
+}
+
+
+
+/**
+ * reading in the mesh triangles
+ */
+int MD3Data::readMeshTriangles(FILE* pFile, int fileOffset, int mesh)
+{
+  PRINTF(0)("Reading Mesh Triangles\n");
+  // create the memomry to save the triangles
+  this->meshes[mesh]->triangles = new MD3Triangle[this->meshes[mesh]->header->triangleNum];
+  fread(this->meshes[mesh]->triangles, 1, sizeof(MD3Triangle) * this->meshes[mesh]->header->triangleNum, pFile);
+
+  return this->meshes[mesh]->header->triangleNum * sizeof(MD3Triangle);
+}
+
+
+/**
+ * reading in the mesh textures
+ */
+int MD3Data::readMeshTextures(FILE* pFile, int fileOffset, int mesh)
+{
+  PRINTF(0)("Reading Mesh Textures\n");
+
+  // create the textures
+  this->meshes[mesh]->material = new Material[this->meshes[mesh]->header->textureNum];
+
+  MD3Texture* tex = new MD3Texture[this->meshes[mesh]->header->textureNum];
+  fread(tex, 1, sizeof(MD3Texture) * this->meshes[mesh]->header->textureNum, pFile);
+
+  for( int i = 0; i < this->meshes[mesh]->header->textureNum; i++) {
+    PRINTF(0)(" texture file: %s\n", tex[i].fileName);
+    this->meshes[mesh]->material[i].setDiffuseMap(tex[i].fileName);
+    this->meshes[mesh]->material[i].setAmbient(1, 1, 1);
+  }
+
+  return this->meshes[mesh]->header->textureNum * sizeof(MD3Texture);
+}
+
+
+/**
+ * reading in the mesh tex vecs
+ */
+int MD3Data::readMeshTexVecs(FILE* pFile, int fileOffset, int mesh)
+{
+  PRINTF(0)("Reading Mesh TexVecs\n");
+
+  this->meshes[mesh]->texVecs = new MD3TexVecs[this->meshes[mesh]->header->vertexNum];
+  fread(this->meshes[mesh]->texVecs, 1, sizeof(MD3TexVecs) * this->meshes[mesh]->header->vertexNum, pFile);
+
+  return this->meshes[mesh]->header->vertexNum * sizeof(MD3TexVecs);
+}
+
+
+/**
+ * reading in the mesh vertices
+ */
+int MD3Data::readMeshVertices(FILE* pFile, int fileOffset, int mesh)
+{
+  PRINTF(0)("Reading Mesh Vertices\n");
+
+  // reserver memory for the vertex informations
+  this->meshes[mesh]->meshFrames = new sVec3D[this->meshes[mesh]->header->meshFrameNum * this->meshes[mesh]->header->vertexNum];
+  this->meshes[mesh]->normals = new MD3Normal[this->meshes[mesh]->header->meshFrameNum * this->meshes[mesh]->header->vertexNum];
+
+  for( int i = 0; i < this->meshes[mesh]->header->meshFrameNum * this->meshes[mesh]->header->vertexNum; i++)
+  {
+    // read out the compressed data
+    MD3VertexCompressed* vc = new MD3VertexCompressed;
+    fread(vc, 1, sizeof(MD3VertexCompressed), pFile);
+
+    this->meshes[mesh]->meshFrames[i][0] = (float)vc->vector[0] / 64.0f;
+    this->meshes[mesh]->meshFrames[i][1] = (float)vc->vector[1] / 64.0f;
+    this->meshes[mesh]->meshFrames[i][2] = (float)vc->vector[2] / 64.0f;
+
+    this->meshes[mesh]->normals[i].vertexNormal[0] = vc->vertexNormal[0];
+    this->meshes[mesh]->normals[i].vertexNormal[1] = vc->vertexNormal[1];
+
+    delete vc;
+  }
+
+  // delete the temp memory again
+//   delete vc;
+
+  return this->meshes[mesh]->header->meshFrameNum * this->meshes[mesh]->header->vertexNum * sizeof(MD3VertexCompressed);
+}
+
+}
+
+
+
+
+
+
+
Index: trunk/src/lib/graphics/importer/md3/md3_data.h
===================================================================
--- trunk/src/lib/graphics/importer/md3/md3_data.h	(revision 8490)
+++ trunk/src/lib/graphics/importer/md3/md3_data.h	(revision 8490)
@@ -0,0 +1,131 @@
+/*!
+ * @file md2Model.h
+  *  Definition of an MD2 Model, a model format invented by ID Software.
+
+    We are deeply thankfull for all the wunderfull things id software made for us gamers!
+
+    The md2 file format is structured in a very simple way: it contains animations which are made out of
+    frames (so called keyframes). Each frame is a complete draweable model in a specific position.
+    A frame is a collection of vertex and its compagnions (normals, texture coordinates).
+
+    A typical model has about 200 frames, the maximum frame count is fixed by MD2_MAX_FRAMES to currently
+    512 frames. The maximal vetices count is set to 2048 verteces, not enough?
+    You just have to change the MD2_MAX_* values if it doesn't fit your purposes...
+
+    Surface Culling is fully implemented in md2 models: quake2 uses front face culling.
+*/
+
+#ifndef _MD3_DATA_H
+#define _MD3_DATA_H
+
+#include "base_object.h"
+
+#include "model.h"
+#include "material.h"
+#include "md_model_structure.h"
+
+
+//! These are the needed defines for the max values when loading .MD2 files
+#define MD3_IDENT                       (('3'<<24) + ('P'<<16) + ('D'<<8) + 'I') //!< the md3 identifier tag in the bin file
+#define MD3_VERSION                     15                                       //!< the md2 version in the header
+#define MD2_MAX_TRIANGLES               4096                                     //!< maximal triangles count
+#define MD2_MAX_VERTICES                2048                                     //!< maximal vertices count
+#define MD2_MAX_TEXCOORDS               2048                                     //!< maximal tex coordinates
+#define MD2_MAX_FRAMES                  512                                      //!< maximal frames
+#define MD2_MAX_SKINS                   32                                       //!< maximal skins
+#define MD2_MAX_FRAMESIZE               (MD2_MAX_VERTICES * 4 + 128)             //!< maximal framesize
+
+#define NUM_VERTEX_NORMALS              162                                      //!< number of vertex normals
+#define SHADEDOT_QUANT                  16                                       //!< shade dot quantity - no idea what it is
+
+//! This stores the speed of the animation between each key frame - currently conflicting with the animation framework
+#define kAnimationSpeed                 12.0f                                    //!< animation speed
+
+
+namespace md3
+{
+
+  class MD3BoneFrame;
+  class MD3Mesh;
+
+//! This holds the header information that is read in at the beginning of the file: id software definition
+struct MD3Header
+{
+   int ident;                           //!< This is used to identify the file
+   int version;                         //!< The version number of the file (Must be 8)
+
+   char filename[68];                   //!< The filename of the model
+
+   int boneFrameNum;                    //!< number of frames
+   int tagNum;                          //!< number of tags
+   int meshNum;                         //!< number of mesh
+   int maxTexNum;                       //!< number of texture
+
+   int boneFrameStart;                  //!< start of bone frames
+   int tagStart;                        //!< start of the tag
+   int meshStart;                       //!< mesh start
+
+   int fileSize;                        //!< file size
+};
+
+
+
+//! class to store the md2 data in
+class MD3Data : public BaseObject
+{
+ public:
+   MD3Data(const std::string& modelFileName, const std::string& skinFileName, float scale = 1.0f);
+  virtual ~MD3Data();
+
+
+ private:
+   bool loadModel(const std::string& fileName);
+   bool loadSkin(const std::string& fileName = "");
+
+   int readHeader(FILE* pFile, int fileOffset);
+   int readBoneFrames(FILE* pFile, int fileOffset);
+   int readTags(FILE* pFile, int fileOffset);
+   int readMeshes(FILE* pFile, int fileOffset);
+
+
+   int readMeshTriangles(FILE* pFile, int fileOffset, int mesh);
+   int readMeshTextures(FILE* pFile, int fileOffset, int mesh);
+   int readMeshTexVecs(FILE* pFile, int fileOffset, int mesh);
+   int readMeshVertices(FILE* pFile, int fileOffset, int mesh);
+
+ public:
+
+  MD3Header*          header;            //!< the header file
+
+  std::string         filename;          //!< the name of the file as recorded in the .md3 file
+  std::string         loadFilename;      //!< filename of the actual file from which data was loaded
+
+  int                 boneFrameNum;      //!< number of anumation key fames in the models
+  int                 tagNum;            //!< number of tags
+  int                 meshNum;           //!< number of meshes
+
+  int                 maxTextureNum;     //!< maximum number of unique used in an md3 file
+  int                 boneFrameStart;    //!< starting position of bone frame data structures
+  int                 tagStart;          //!< starting position of tag-structures
+
+  int                 meshStart;         //!< starting position of mesh structures
+
+  int                 fileSize;          //!< file size
+
+
+  MD3BoneFrame**      boneFrames;        //!< array of bone frames, contains the metadata (bounding box, tags,...) for each frame
+  MD3Mesh**           meshes;            //!< array of meshes in the model. each containing the mesh for each of the animation
+
+  int                 parentTagIndex;    //!< tag index
+
+  //MD3Model*           parent;            //!< reference to the MD3Model
+
+
+};
+
+
+}
+
+
+
+#endif /* _MD3_DATA_H */
Index: trunk/src/lib/graphics/importer/md3/md3_mesh.cc
===================================================================
--- trunk/src/lib/graphics/importer/md3/md3_mesh.cc	(revision 8490)
+++ trunk/src/lib/graphics/importer/md3/md3_mesh.cc	(revision 8490)
@@ -0,0 +1,38 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
+
+#include "md3_mesh.h"
+
+
+namespace md3
+{
+
+/**
+ *  md3 mesh constructor
+ */
+MD3Mesh::MD3Mesh()
+{
+}
+
+
+/**
+ * md3 mesh deconstructor
+ */
+MD3Mesh::~MD3Mesh()
+{}
+
+}
+
Index: trunk/src/lib/graphics/importer/md3/md3_mesh.h
===================================================================
--- trunk/src/lib/graphics/importer/md3/md3_mesh.h	(revision 8490)
+++ trunk/src/lib/graphics/importer/md3/md3_mesh.h	(revision 8490)
@@ -0,0 +1,86 @@
+/*!
+ * @file md3_mesh.h
+ *
+ * Code heavely inspired by: JAVA MD3 Model Viewer - A Java based Quake 3 model viewer
+ * Copyright (C) 1999 Erwin 'KLR8' Vervaet
+ */
+
+#ifndef _MD3_MESH_H
+#define _MD3_MESH_H
+
+
+#include <string>
+
+#include "md_model_structure.h"
+
+#include "vector.h"
+
+class Material;
+
+
+namespace md3
+{
+
+  typedef struct MD3MeshHeader {
+
+    int     id;                             //!< individual id, must be IDP3
+    char    name[68];                       //!< the name of the mesh
+
+    int     meshFrameNum;                   //!< numbers of frames
+    int     textureNum;                     //!< numbers of textures
+    int     vertexNum;                      //!< numbers of verteces
+    int     triangleNum;                    //!< number of triangles
+
+    int     triangleStart;                  //!< triangle start offset
+    int     textureStart;                   //!< texture start offset
+    int     texVecStart;                    //!< tex vec start offset
+    int     vertexStart;                    //!< vertex start offset
+
+    int     meshSize;                       //!< total mesh size
+  };
+
+
+  typedef struct MD3Triangle  {
+    int     vertexOffset[3];                //!< the vertex offsets of the triangles in the vertex array
+  };
+
+  typedef struct MD3Texture {
+    char    fileName[68];                   //!< the filename of the texture. path relativly to the model file
+  };
+
+  typedef struct MD3TexVecs {
+    float   textureCoord[2];                //!< the texture u/v coordinates
+  };
+
+  typedef struct MD3Normal {
+    int     vertexNormal[2];                //!< vertex normals
+  };
+
+  typedef struct MD3VertexCompressed {
+    short   vector[3];                      //!< compressed vertex information
+    unsigned char vertexNormal[2];          //!< vertex normals compressed
+  };
+
+
+
+class MD3Mesh
+{
+  public:
+    MD3Mesh();
+    virtual ~MD3Mesh();
+
+
+  public:
+    MD3MeshHeader*     header;                  //!< the header of the mesh
+
+    Material*          material;                //!< the material/textures of the models
+    MD3Triangle*       triangles;               //!< indices into mesh frames and texture coord arrays
+    MD3TexVecs*        texVecs;                 //!< tex vecs coordinates
+    sVec3D*            meshFrames;              //!< mesh frames
+    MD3Normal*         normals;                 //!< 3d array of normals with spherical coordinates giving the dir of the vertex normal
+
+};
+
+}
+
+#endif /* _MD3_MESH_H */
Index: trunk/src/lib/graphics/importer/md3/md3_model.cc
===================================================================
--- trunk/src/lib/graphics/importer/md3/md3_model.cc	(revision 8490)
+++ trunk/src/lib/graphics/importer/md3/md3_model.cc	(revision 8490)
@@ -0,0 +1,39 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
+
+#include "md3_model.h"
+
+#include "md3_data.h"
+
+
+namespace md3
+{
+
+  /**
+   * md3 model
+   */
+  MD3Model::MD3Model(std::string filename, float scaling)
+  {
+    this->md3Data = new MD3Data(filename, filename, scaling);
+  }
+
+
+
+  MD3Model::~MD3Model()
+  {}
+
+
+}
Index: trunk/src/lib/graphics/importer/md3/md3_model.h
===================================================================
--- trunk/src/lib/graphics/importer/md3/md3_model.h	(revision 8490)
+++ trunk/src/lib/graphics/importer/md3/md3_model.h	(revision 8490)
@@ -0,0 +1,37 @@
+/*!
+ * @file md3_model.h
+ *
+ * Code heavely inspired by: JAVA MD3 Model Viewer - A Java based Quake 3 model viewer
+ * Copyright (C) 1999 Erwin 'KLR8' Vervaet
+ */
+
+#ifndef _MD3_MODEL_H
+#define _MD3_MODEL_H
+
+#include <string>
+#include "interactive_model.h"
+
+
+namespace md3
+{
+
+
+class MD3Data;
+
+class MD3Model : public InteractiveModel
+{
+
+  public:
+    MD3Model(std::string filename, float scaling);
+    ~MD3Model();
+
+    virtual void tick(float dt) {}
+    virtual void setAnimation(int animNum, int playbackMode = 0) {}
+
+  private:
+    MD3Data*            md3Data;           //!< reference to the md3 model data
+};
+
+}
+
+#endif /* _MD3_MODEL_H */
Index: trunk/src/lib/graphics/importer/md3/md3_tag.cc
===================================================================
--- trunk/src/lib/graphics/importer/md3/md3_tag.cc	(revision 8490)
+++ trunk/src/lib/graphics/importer/md3/md3_tag.cc	(revision 8490)
@@ -0,0 +1,35 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_IMPORTER
+
+#include "md3_tag.h"
+
+
+
+namespace md3
+{
+
+
+
+  MD3Tag::MD3Tag()
+  { /* loadMesh(this, din) */ }
+
+
+  MD3Tag::~MD3Tag()
+  {}
+
+
+}
+
Index: trunk/src/lib/graphics/importer/md3/md3_tag.h
===================================================================
--- trunk/src/lib/graphics/importer/md3/md3_tag.h	(revision 8490)
+++ trunk/src/lib/graphics/importer/md3/md3_tag.h	(revision 8490)
@@ -0,0 +1,43 @@
+/*!
+ * @file md3_mesh.h
+ *
+ * Code heavely inspired by: JAVA MD3 Model Viewer - A Java based Quake 3 model viewer
+ * Copyright (C) 1999 Erwin 'KLR8' Vervaet
+ */
+
+#ifndef _MD3_TAG_H
+#define _MD3_TAG_H
+
+#include <string>
+
+#include "vector.h"
+
+namespace md3
+{
+
+typedef struct MD3TagData
+{
+  char       name[64];                                //!< name of the tag
+  sVec3D     position;                                //!< position of the tag
+  float      matrix[3][3];                            //!< matrix of the rotation
+};
+
+
+class MD3Tag
+{
+  public:
+    MD3Tag();
+    virtual ~MD3Tag();
+
+
+  public:
+    std::string               name;                   //!< name of tag as its usualy called in the md3 file
+    Vector                    position;               //!< the position of the tag reltive to the models containing that tag
+    float                     matrix[3][3];           //!< 3x3 rotation matrix
+
+    MD3TagData*               data;                   //!< data reference
+};
+
+}
+
+#endif /* _MD3_TAG_H */
Index: trunk/src/lib/graphics/importer/md_model_structure.h
===================================================================
--- trunk/src/lib/graphics/importer/md_model_structure.h	(revision 8490)
+++ trunk/src/lib/graphics/importer/md_model_structure.h	(revision 8490)
@@ -0,0 +1,88 @@
+/*!
+ * @file md_model_structure.h
+ */
+
+
+
+#ifndef _MD3_MODEL_STRUCTURE_H
+#define _MD3_MODEL_STRUCTURE_H
+
+
+#include "vector.h"
+
+
+//! compressed vertex data: char insetead of float, the value will be expanded by the scale value. only for loading
+typedef struct
+{
+  unsigned char    v[3];                 //!< the vector of the vertex
+  unsigned char    lightNormalIndex;     //!< the index of the light normal
+} sVertex;
+
+
+//! compressed texture offset data: coords scaled by the texture size. Only for loading
+typedef struct
+{
+  short            s;                    //!< the s,t coordinates of a texture
+  short            t;                    //!< the s,t coordinates of a texture
+} sTexCoor;
+
+
+//! holds tha informations about a md2 frame
+typedef struct
+{
+  sVec3D           scale;                //!< scales values of the model
+  sVec3D           translate;            //!< translates the model
+  char             name[16];             //!< frame name: something like "run32"
+  sVertex          pVertices[1];         //!< first vertex of thes frame
+} sFrame;
+
+
+//! holds the information about a triangle
+typedef struct
+{
+  unsigned short   indexToVertices[3];   //!< index to the verteces of the triangle
+  unsigned short   indexToTexCoor[3];    //!< index to the texture coordinates
+} sTriangle;
+
+
+
+//! the command list of the md2 model, very md2 specific
+typedef struct
+{
+  float            s;                    //!< texture coordinate 1
+  float            t;                    //!< texture coordinate 2
+  int              vertexIndex;          //!< index of the vertex in the vertex list
+} glCommandVertex;
+
+
+//! a md2 animation definition
+typedef struct
+{
+  int              firstFrame;           //!< first frame of the animation
+  int              lastFrame;            //!< last frame of the animation
+  int              fps;                  //!< speed: number of frames per second
+  int              bStoppable;           //!< 1 if the animation is stoppable 0 else
+} sAnim;
+
+
+//! animation state definition
+typedef struct
+{
+  int              startFrame;           //!< the start frame of an animation
+  int              endFrame;             //!< last frame of the animation
+  int              fps;                  //!< fps of the animaion (speed)
+
+  float            localTime;            //!< the local time
+  float            lastTime;             //!< last time stamp
+  float            interpolationState;   //!< the state of the animation [0..1]
+
+  int              type;                 //!< animation type
+
+  int              currentFrame;         //!< the current frame
+  int              nextFrame;            //!< the next frame in the list
+  int              numPlays;             //!< the number of times, this has been played in series
+
+  int              animPlaybackMode;     //!< the playback mode
+} sAnimState;
+
+#endif /* _MD3_MODEL_STRUCTURE_H */
Index: trunk/src/lib/math/vector.h
===================================================================
--- trunk/src/lib/math/vector.h	(revision 8450)
+++ trunk/src/lib/math/vector.h	(revision 8490)
@@ -46,4 +46,6 @@
   /** @param v: the Vecor to compare with this one @returns true, if the Vecors are the same, false otherwise */
   inline bool operator== (const Vector& v) const { return (this->x==v.x&&this->y==v.y&&this->z==v.z)?true:false; };
+  /** @param v: the Vecor to compare with this one @returns true, if the Vecors are different, false otherwise */
+  inline bool operator!= (const Vector& v) const { return (this->x!=v.x&&this->y!=v.y&&this->z!=v.z)?true:false; };
   /** @param index The index of the "array" @returns the x/y/z coordinate */
   inline float operator[] (float index) const {if( index == 0) return this->x; if( index == 1) return this->y; if( index == 2) return this->z; }
Index: trunk/src/lib/util/loading/resource_manager.cc
===================================================================
--- trunk/src/lib/util/loading/resource_manager.cc	(revision 8450)
+++ trunk/src/lib/util/loading/resource_manager.cc	(revision 8490)
@@ -27,5 +27,5 @@
 #include "objModel.h"
 #include "primitive_model.h"
-#include "md2Model.h"
+#include "md2/md2Model.h"
 #endif /* NO_MODEL */
 #ifndef NO_TEXTURES
